/* --------------------------------------------------------------------------------------------
 * Copyright (c) 2024 TypeFox and others.
 * Licensed under the MIT License. See LICENSE in the package root for license information.
 * ------------------------------------------------------------------------------------------ */
export class Logger {
    enabled;
    debugEnabled;
    constructor(config) {
        this.updateConfig(config);
    }
    updateConfig(config) {
        this.enabled = !config ? true : config.enabled === true;
        this.debugEnabled = this.enabled && config?.debugEnabled === true;
    }
    isEnabled() {
        return this.enabled;
    }
    isDebugEnabled() {
        return this.debugEnabled;
    }
    info(message) {
        if (this.enabled) {
            console.log(message);
        }
    }
    debug(message, force) {
        if (this.enabled && (this.debugEnabled || force === true)) {
            console.debug(message);
        }
    }
}
//# sourceMappingURL=index.js.map